////////////////////////////////////////////////////////////////////
//////// Copy Right 2009 by H Cheng   //////////////////////////////
////////////////////////////////////////////////////////////////////
#ifndef GA_Multicast_H
#define GA_Multicast_H
#define MAX 100
#define Length 100
#include <iostream>
using namespace std;
#include <fstream>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <vector>

fstream fin;
fstream fout;

int WhichTopo;
int Size;
int Node;
int interval_change;
int Step;
int Repeat;
double ratio_eRI;
int LinkNumPerChange;
int Count;
double ratio_eRI_mut;
int RandomSeed[30];
double treecost[1800];
double costarray[10][310];
double wholepop_ave[310];//first time run
double wholepop_var[310];//first time run
time_t t1,t2;
int Source;
int a[2];
vector<int> Destination;
//// Temp Storage Vector (Replace Genes)
vector<int> Temp1;
vector<int> Temp2;
vector<int> Temp3;
vector<int> Temp4;

vector<int> X;
vector<int> Y;
/////// Declare Population Information ///////
struct
{
	int Temp_chromosome[Length][Length];
	vector<int> PathLength;
	vector<int> checkedNode;
	double fitness;
}Routing[2*MAX],cur_elitism_indi,pre_elitism_indi;

class GA_Multicast
{
	private:
		int Connect[Length][Length];      //Confirm Connection
		int Cost[Length][Length];         //Cost Matrix
		int Connect_backup[Length][Length];      //Confirm Connection
		int Cost_backup[Length][Length];         //Cost Matrix
		int Temp_Connect[Length][Length]; //Tempairly Confirm Connection 		 
		int Temp_Cost[Length][Length];
		
		int cTemp[MAX];					  //Storage Random Crossover Location
		double rateMutation,rateCrossover;	 //Mutation Rate
		
	public:	
		GA_Multicast();
		void Step_Init();
		int iRandom(int);      // int Random generator 
		double dRandom();      // Double Random generator
		/////// Initionalize Population ////////
		void Init();
		void Population(int);  // Make Random Population  
		void Encoding(int,int);
        void Init_Temp_Matrices();
        void Init_Encoding(int,int,int);
        void Delete_Path(int);
        int nextLocation(int);
        ////// Fitness Function ///////////
		void Fitness_Function();
		/////// Tournament Selection //////////
		void Shuffle();
		void chromosomeExchange(int,int);
		void Tournament_Selection();
		void Max(int,int);
		void Mix(int,int);
		/////// Crossover /////////
		void Init_Crossover();
		void Run_Crossover(int,int);
		void Exchange_subtree(int,int,int,int,int);
		int  Check_Crossover();
		void Repair_Function();
		void Crossover();
		void Crosspoinit_Init();
		void Crossover1(int,int,int);  //First Corssover
		void Crossover2(int,int,int);  //Second Crossover
		void Crosspoint(int,int);      //Find Crossover Point
		void cCrossInit(int,int);      //Tempairly Init
		/////// Mutation ////////
		void Mutation();
		void Run_Mutation(int,int,int);
		void Mutation_Encoding(int,int,int);
		void mPopulation(int,int);     // Make Random Population  
		void mTTemp(int,int);
		/////// Recovery ////////
		//void Recovery();
		void reCombination(int,int,int);
		void Check_Recombination(int, int);
		void Run_Recombination(int,int,int,int,int);
		void Check_Path(int);
		////// Print Shortest Path ////
		void Print(int,int);
		void Print_Average(int,int);
		////// Detect Convergence ////
		int  Convergence();
		///// Everything Init ////
		void Fitness_Individual(int);
		void Elitism_Select();
        void Elitism_Replace();
		void Routing_Init();
		void Random_Immi(int);
		void Read_Topo();
		void GenNewTopo();
		void Repair_InfeasibleIndividual(int);
		void Repair_Population();
		void Mutation_Individual(int);
		void Elitism_Immi(int, double);
		bool InChromosome(int, int, int*, int*);
		bool BrokenLinkExist(int);
};
#endif
